#ifndef _OcclusionCullingTerrainSceneTraverser_H__
#define _OcclusionCullingTerrainSceneTraverser_H__

#include "OgreOctree.h"
#include "OgreOcclusionCullingSceneTraverser.h"

using namespace std;

namespace Ogre {
void Octree::_getCullBounds( AxisAlignedBox *b )
	typedef pair<Octree *, HardwareOcclusionQuery *> OctreeQueryPair;
	typedef priority_queue<Octree *, vector<Octree *>, myless<vector<Octree *>::value_type> > OctreePriorityQueue;
	//typedef queue<QueryPair> QueryQueue;

	class OcclusionCullingTerrainSceneTraverser: OcclusionCullingSceneTraverser
	{
		void renderScene( Camera *cam, Octree *root );
		void renderCullFrustum( Camera *cam );
		void pullUpVisibility( Octree *node );
		void traverseNode( Camera *cam, Octree *node );

	protected:
		OctreePriorityQueue *mDistanceQueue;
	};

}
#endif // OcclusionCullingTerrainSceneTraverser_H